const APPLICABLE_PROTOCOLS = ["https:"];
const TITLE_APPLY = "NoMorePass qr";
const TITLE_REMOVE = "NoMorePass off";

var pass_in_tabs = [];
var url_in_tab = {};

const WEB_REQUEST = browser.webRequest;

WEB_REQUEST.onBeforeRequest.addListener(
    function(details) {
        if(details.method == "POST") {
          var url = details.documentUrl;
          if (url in url_in_tab) {
            // Es una de las que declaró tener password
            var formData = details.requestBody.formData;
            //console.log (formData);
            //TODO: tratar de ver si tenemos esa contraseña
            // y si no es así ofrecerse para que la envíe
            // al teléfono
            // EXPERIMENTAL: NOT IN THIS VERSION
          }
        }
    },
    {urls: ["<all_urls>"]},
    ["blocking", "requestBody"]
);

browser.contextMenus.create({
  id: "copy-pass-to-field",
  title: browser.i18n.getMessage("NoMorePassMenu"),
  contexts: ["editable","password"],
});

browser.contextMenus.onClicked.addListener((info, tab) => {
  if (info.menuItemId === "copy-pass-to-field") {
     
      const code = "showClipboardQr()";
          
      browser.tabs.executeScript({
          code: "typeof showClipboardQr === 'function';",
      }).then((results) => {
          if (!results || results[0] !== true) {
              return browser.tabs.executeScript(tab.id, {
                  file: "/src/inject/inject.js",
              });
          }
      }).then(() => {
          return browser.tabs.executeScript(tab.id, {
              code,
          });
      }).catch((error) => {
          console.error("Failed: " + error);
      });
  }
});

function showQr(tab) {

  function gotTitle(title) {
    if (title === TITLE_APPLY) {
      //browser.pageAction.setIcon({tabId: tab.id, path: "icons/icon19.png"});
      browser.browserAction.setTitle({tabId: tab.id, title: TITLE_REMOVE});
      sendQrMsg(tab,"showQr");
    } else {
      //browser.pageAction.setIcon({tabId: tab.id, path: "icons/icon19_b.png"});
      browser.browserAction.setTitle({tabId: tab.id, title: TITLE_APPLY});
      sendQrMsg(tab,"hideQr");
    }
  }

  var gettingTitle = browser.browserAction.getTitle({tabId: tab.id});
  gettingTitle.then(gotTitle);
}

/*
Returns true only if the URL's protocol is in APPLICABLE_PROTOCOLS.
*/
function protocolIsApplicable(url) {
  var anchor =  document.createElement('a');
  anchor.href = url;
  return APPLICABLE_PROTOCOLS.includes(anchor.protocol);
}

/*
Initialize the page action: set icon and title, then show.
Only operates on tabs whose URL's protocol is applicable.
*/
function initializePageAction(tab) {
  //console.log("Initializing: "+tab.id);
  if (protocolIsApplicable(tab.url)) {
    browser.browserAction.setIcon({tabId: tab.id, path: "icons/icon19.png"});
    browser.browserAction.setTitle({tabId: tab.id, title: TITLE_APPLY});
    browser.browserAction.enable(tab.id);
  } else {
    browser.browserAction.setIcon({tabId: tab.id, path: "icons/icon19_off.png"});
    browser.browserAction.setTitle({tabId: tab.id, title: TITLE_REMOVE});
    browser.browserAction.disable(tab.id);
  }
}

/*
When first loaded, initialize the page action for all tabs.

var gettingAllTabs = browser.tabs.query({});
gettingAllTabs.then((tabs) => {
  for (tab of tabs) {
    initializePageAction(tab);
  }
});
*/

/*
Each time a tab is updated, reset the page action for that tab.
*/
browser.tabs.onUpdated.addListener((id, changeInfo, tab) => {
  initializePageAction(tab);
});

//browser.pageAction.onClicked.addListener(showQr);
browser.browserAction.onClicked.addListener(showQr);

browser.runtime.onMessage.addListener(function(msg, sender, response) {
  //console.log(msg);
    if (msg.nopass) {
        response();
        //console.log("No hay pass en "+sender.tab.id);
        delete url_in_tab [msg.nopass];
        if (pass_in_tabs.indexOf(sender.tab.id)==-1){
          browser.browserAction.setIcon({tabId: sender.tab.id, path: "icons/icon19_off.png"});
          browser.browserAction.setTitle({tabId: sender.tab.id, title: TITLE_REMOVE});
          //browser.browserAction.setPopup({tabId: tab.id,popup: "/popup/popup.html"});
          browser.browserAction.disable(sender.tab.id);
        }
    } else  
    if (msg.pass) {
      response();
      //console.log("Hay pass en "+sender.tab.id);
      pass_in_tabs.push(sender.tab.id);
      url_in_tab[msg.pass] = sender.tab.id;
      browser.browserAction.setIcon({tabId: sender.tab.id, path: "icons/icon19.png"});
      browser.browserAction.setTitle({tabId: sender.tab.id, title: TITLE_APPLY});
      //browser.browserAction.setPopup({tabId: tab.id,popup: ""});
      browser.browserAction.enable(sender.tab.id);
    }
    if (msg.inject) {
      // Inyectamos en las iframes que no estaba...
      var num = msg.inject;
      for (var i = 0; i<num; i++) {
        browser.tabs.executeScript(sender.tab.id, {
            file: "/src/inject/inject.js",
            allFrames: false,
            frameId: i+1
        }, function() {
            //console.log("Inyectado...");
            //if (!browser.runtime.lastError) {
            //    onPageActionClicked(tab);
            //}
        });
      }
    }
});

function sendQrMsg(tab,msg) {
  browser.tabs.sendMessage(tab.id, { action: msg }, function() {
        if (browser.runtime.lastError) {
            browser.tabs.executeScript(tab.id, {
                file: "/src/inject/inject.js"
            }, function() {
                if (!browser.runtime.lastError) {
                    onPageActionClicked(tab);
                }
            });
        }
    });
}
